Sign Up

Sign Up to our social questions and Answers Engine to ask questions, answer people’s questions, and connect with other people.

Have an account? Sign In

Have an account? Sign In Now

Sign In

Login to our social questions & Answers Engine to ask questions answer people’s questions & connect with other people.

Sign Up Here

Forgot Password?

Don't have account, Sign Up Here

Forgot Password

Lost your password? Please enter your email address. You will receive a link and will create a new password via email.

Have an account? Sign In Now

You must login to ask a question.

Forgot Password?

Need An Account, Sign Up Here

Please briefly explain why you feel this question should be reported.

Please briefly explain why you feel this answer should be reported.

Please briefly explain why you feel this user should be reported.

Sign InSign Up

The Archive Base

The Archive Base Logo The Archive Base Logo

The Archive Base Navigation

  • Home
  • SEARCH
  • About Us
  • Blog
  • Contact Us
Search
Ask A Question

Mobile menu

Close
Ask a Question
  • Home
  • Add group
  • Groups page
  • Feed
  • User Profile
  • Communities
  • Questions
    • New Questions
    • Trending Questions
    • Must read Questions
    • Hot Questions
  • Polls
  • Tags
  • Badges
  • Buy Points
  • Users
  • Help
  • Buy Theme
  • SEARCH
Home/ Questions/Q 38211
In Process

The Archive Base Latest Questions

Editorial Team
  • 0
Editorial Team
Asked: May 10, 20262026-05-10T14:40:21+00:00 2026-05-10T14:40:21+00:00

I have a shell script that executes a number of commands. How do I

  • 0

I have a shell script that executes a number of commands. How do I make the shell script exit if any of the commands exit with a non-zero exit code?

  • 1 1 Answer
  • 0 Views
  • 0 Followers
  • 0
Share
  • Facebook
  • Report

Leave an answer
Cancel reply

You must login to add an answer.

Forgot Password?

Need An Account, Sign Up Here

1 Answer

  • Voted
  • Oldest
  • Recent
  • Random
  1. 2026-05-10T14:40:22+00:00Added an answer on May 10, 2026 at 2:40 pm

    After each command, the exit code can be found in the $? variable so you would have something like:

    ls -al file.ext rc=$?; if [[ $rc != 0 ]]; then exit $rc; fi 

    You need to be careful of piped commands since the $? only gives you the return code of the last element in the pipe so, in the code:

    ls -al file.ext | sed 's/^/xx: /' 

    will not return an error code if the file doesn’t exist (since the sed part of the pipeline actually works, returning 0).

    The bash shell actually provides an array which can assist in that case, that being PIPESTATUS. This array has one element for each of the pipeline components, that you can access individually like ${PIPESTATUS[0]}:

    pax> false | true ; echo ${PIPESTATUS[0]} 1 

    Note that this is getting you the result of the false command, not the entire pipeline. You can also get the entire list to process as you see fit:

    pax> false | true | false; echo ${PIPESTATUS[*]} 1 0 1 

    If you wanted to get the largest error code from a pipeline, you could use something like:

    true | true | false | true | false rcs=${PIPESTATUS[*]}; rc=0; for i in ${rcs}; do rc=$(($i > $rc ? $i : $rc)); done echo $rc 

    This goes through each of the PIPESTATUS elements in turn, storing it in rc if it was greater than the previous rc value.

    • 0
    • Reply
    • Share
      Share
      • Share on Facebook
      • Share on Twitter
      • Share on LinkedIn
      • Share on WhatsApp
      • Report

Sidebar

Ask A Question

Stats

  • Questions 158k
  • Answers 158k
  • Best Answers 0
  • User 1
  • Popular
  • Answers
  • Editorial Team

    How to approach applying for a job at a company ...

    • 7 Answers
  • Editorial Team

    How to handle personal stress caused by utterly incompetent and ...

    • 5 Answers
  • Editorial Team

    What is a programmer’s life like?

    • 5 Answers
  • Editorial Team
    Editorial Team added an answer Eclipse puts the words you add into a text file,… May 12, 2026 at 11:14 am
  • Editorial Team
    Editorial Team added an answer Even with the cast, the comparison is still true in… May 12, 2026 at 11:14 am
  • Editorial Team
    Editorial Team added an answer Divide by 1000? May 12, 2026 at 11:14 am

Related Questions

I have the requirement for a web script to execute an exe file and
I have some Perl code that executes a shell script for multiple parameters, to
I have a shell script that saves the output of a command that is
Objective : Make a progress bar where users can check how much of a

Trending Tags

analytics british company computer developers django employee employer english facebook french google interview javascript language life php programmer programs salary

Top Members

Explore

  • Home
  • Add group
  • Groups page
  • Communities
  • Questions
    • New Questions
    • Trending Questions
    • Must read Questions
    • Hot Questions
  • Polls
  • Tags
  • Badges
  • Users
  • Help
  • SEARCH

Footer

© 2021 The Archive Base. All Rights Reserved
With Love by The Archive Base

Insert/edit link

Enter the destination URL

Or link to existing content

    No search term specified. Showing recent items. Search or use up and down arrow keys to select an item.